unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, AppEvnts, StdCtrls, dglopengl, _shader, _model, _smdloader, _smd2loader, _render,_textures,_types,_mmtime;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    ApplicationEvents1: TApplicationEvents;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    procedure DrawOpenGL;
    procedure BeforeStart;
    procedure BeforeExit;
    procedure Form1create(Sender: TObject);
    procedure Form1resize(Sender: TObject);
    procedure Form1destroy(Sender: TObject);
    procedure OnIdleProc(Sender: TObject; var Done: Boolean);
    procedure ScrollBar1change(Sender: TObject);
  private
    { Private declarations }
    rc : HGLRC;    // RC
    dc  : HDC;     // DC
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

//      /
var FShaders: array of GLhandleARB;

//       
shader_boneMat: glInt;

//      
shader_myTexture:array[0..7] of glInt;



var models:TModels; //       

//      
// (    21 )
var skelstate:array[0..300-1] of TSkelAnimState;


implementation

{$R *.dfm}


procedure TForm1.DrawOpenGL;
var i,j,k:integer;
begin


 //    
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glLoadIdentity();

 //  
 gluLookAt(0,-350,100, //  
           0,0,0,    //  
           0,0,1);    //    

    glRotatef(gettickcount/100,0,0,1);
 //   
 //  , 
 //    
 // Render-.

 //   ,   
 BlenderElapsed:=mmtimeElapsed;


     j:=length(skelState)-ScrollBar1.Position;

     //    
     for i:= 0 to 7 do
      glUniform1iARB(shader_myTexture[i],i);

     //  glBindTexture    
     for i:= 0 to 7 do
      begin
       glActiveTexture(GL_TEXTURE0+i);
     	 glBindTexture(GL_TEXTURE_2D, i+1);
      end;

     glUseProgramObjectARB(FShaders[0]); //   FShaders[0]


     for i := 0 to j- 1 do
      begin


     AnimateModel(models,
                0,
                0,
                1,
                skelState[i], //     i- 
                false);


     CopyBonesForShader(skelState[i]); //      

     //    
     glUniformMatrix4fv( shader_boneMat, 32, false,@skelState[i].shaderAbsoluteMat);


       glPushMatrix;
       glTranslatef((30+5*i)*sin((j+6.28)*i/j),
                    (30+5*i)*cos((j+6.28)*i/j),0); //  
       renderVBO(models[0]);
       glPopMatrix;
      end;

 SwapBuffers(DC);

end;

procedure TForm1.BeforeStart;
  var
  vertex: GLhandleARB;
  fragment: GLhandleARB;
  po:GLhandleARB;
  i:integer;

begin


  //     
  vertex := LoadShaderFromFile('.\shaders\vertex12.txt', GL_VERTEX_SHADER_ARB);
  fragment := LoadShaderFromFile('.\shaders\fragment.txt', GL_FRAGMENT_SHADER_ARB);

  SetLength(FShaders, 0);

  SetLength(FShaders, Length(FShaders) + 1);

  //      
  FShaders[0]:=LinkPrograms([vertex,fragment]);

  po:=FShaders[0];

  //       
  shader_boneMat := glGetUniformLocationARB(po, PGLcharARB(PChar('boneMat')));
  for  i:= 0 to 7 do
  shader_myTexture[i] := glGetUniformLocationARB(po, PGLcharARB(PChar('myTexture'+intToStr(i))));

  //     (Half-Life 1)

  smd_AddModel(models,'.\models\c_marine.smd');
  smd_AddAnimation(models,'.\models\run.smd');


  // Half-Life 2 (beta version loader)
//  smd2_AddModel(models,'.\hl2models\police.smd');
//  smd2_AddAnimation(models,'.\hl2models\deploy.smd');


  //   
  LoadTextures(models,'.\textures\');

  //   
  PrepareSkeletalAnimation(models);


  randomize;
  //        
  for i := 0 to length(skelstate) - 1 do
    begin
     ResetSkelAnimState(SkelState[i],Models[0].skelanim.nodesNum);
     skelState[i].prevFrame:=0;
     skelState[i].nextFrame:=random(21); //   
     skelState[i].prevAction:=0;
     skelState[i].nextAction:=0;
     skelState[i].skelTime:=random(100)/100; //   
    end;

 //  -   
 mmtimeAlloc;

 makeVBO(Models[0]);

 ScrollBar1.SetParams(length(skelState) div 2,0,length(skelState)-1);

end;

procedure TForm1.BeforeExit;
begin
  //  -
  mmtimeFree;

  //    
  glDeleteObjectARB( FShaders[0] );

  glDeleteBuffersARB(1, @Models[0].VBOlink);

end;

procedure TForm1.Form1create(Sender: TObject);
var pfd : TPIXELFORMATDESCRIPTOR;
    pf  : Integer;
begin

  InitOpenGL(); //  dglOpengl

  DecimalSeparator:='.';
  dc:=GetDC(Panel3.Handle);

  pfd.nSize:=sizeof(pfd);
  pfd.nVersion:=1;
  pfd.dwFlags:=PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or 0;
  pfd.iPixelType:=PFD_TYPE_RGBA;
  pfd.cColorBits:=32;

  pf :=ChoosePixelFormat(dc, @pfd);


  SetPixelFormat(dc, pf, @pfd);

  rc :=wglCreateContext(dc);    // RC
  wglMakeCurrent(dc,rc);        // DC

  glClearColor(0.3, 0.3, 0.3, 1.0);
  glShadeModel(GL_SMOOTH);
  glClearDepth(1.0);
  glEnable(GL_DEPTH_TEST);
  glDepthFunc(GL_LEQUAL);

  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

  glEnable(GL_TEXTURE_2D);

  beforeStart;


end;

procedure TForm1.Form1destroy(Sender: TObject);
begin

  beforeExit;

  wglMakeCurrent(0,0);
  wglDeleteContext(rc);

end;

procedure TForm1.Form1resize(Sender: TObject);
begin

  glViewport(0, 0, Panel3.Width, Panel3.Height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(45.0, Panel3.Width/Panel3.Height, 1, 2000.0);

  glMatrixMode(GL_MODELVIEW);


end;

procedure TForm1.OnIdleProc(Sender: TObject; var Done: Boolean);
begin

  DrawOpenGL;
  done:=false

end;

procedure TForm1.ScrollBar1change(Sender: TObject);
begin
 Label1.Caption:='Models rendered: '+IntToStr(length(skelState)-ScrollBar1.Position);
end;

end.
